#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NODE_MAX 1000	//max node number
#define EDGE_MAX 1000	//max edge number
#define EDGE_MAX_NODE 50	//max edge number of one node
#define NODE_MAX_PATH 100	//max node number in a path
#define EDGE_MAX_PATH 100	//max edge number in a path
#define STACK_MAX 500		//max number of stack
#define AVAIL_MAX 50		//max avail edge number

#define TYPE_ZERO_NODE 4	//node number of type0
#define TYPE_ZERO_EDGE 6	//edge number of type0

#define TYPE_ONE_NODE 4		//node number of type1
#define TYPE_ONE_EDGE 5		//edge number of type1

#define TYPE_TWO_NODE 4		//node number of type2
#define TYPE_TWO_EDGE 5		//edge number of type2

#define TYPE_THREE_NODE 4	//node number of type3
#define TYPE_THREE_EDGE 7	//edge number of type3

#define TYPE_FOUR_NODE 5	//node number of type4
#define TYPE_FOUR_EDGE 9	//edge number of type4

#define TYPE_FIVE_NODE 5	//node number of type5
#define TYPE_FIVE_EDGE 6	//edge number of type5

#define TYPE_SIX_NODE 5		//node number of type6
#define TYPE_SIX_EDGE 8		//edge number of type6

#define TYPE_SEVEN_NODE 5	//node number of type7
#define TYPE_SEVEN_EDGE 7	//edge number of type7

#define TYPE_EIGHT_NODE 5	//node number of type8
#define TYPE_EIGHT_EDGE 7	//edge number of type8

#define Node int

//edge structure
typedef struct Edge
{
	int num;	//edge's number
	Node v1;	//v1 node
	Node v2;	//v2 node
}Edge;

//path structure
typedef struct Path
{
	int node_num;
	int edge_num;
	Node path_node[NODE_MAX_PATH];
	Edge path_edge[EDGE_MAX_PATH];
}Path;

Node MyNode[NODE_MAX];	//node array
Edge MyEdge[EDGE_MAX];	//edge array
int Degree[NODE_MAX];	//node degree
int NodeNum;			//node number
int EdgeNum;			//edge number

//create the graph
void CreateGraph(int type)
{
	int i;
	if(type == 0)
	{
		NodeNum = TYPE_ZERO_NODE;
		EdgeNum = TYPE_ZERO_EDGE;
		for(i=1; i<=TYPE_ZERO_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_ZERO_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[1];
		MyEdge[3].v2 = MyNode[3];
		MyEdge[4].v1 = MyNode[3];
		MyEdge[4].v2 = MyNode[4];
		MyEdge[5].v1 = MyNode[3];
		MyEdge[5].v2 = MyNode[4];
		MyEdge[6].v1 = MyNode[1];
		MyEdge[6].v2 = MyNode[4];
	}
	if(type == 1)
	{
		NodeNum = TYPE_ONE_NODE;
		EdgeNum = TYPE_ONE_EDGE;
		for(i=1; i<=TYPE_ONE_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_ONE_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[3];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[4];
	}
	else if(type == 2)
	{
		NodeNum = TYPE_TWO_NODE;
		EdgeNum = TYPE_TWO_EDGE;
		for(i=1; i<=TYPE_TWO_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_TWO_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[3];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[3];
	}
	else if(type == 3)
	{
		NodeNum = TYPE_THREE_NODE;
		EdgeNum = TYPE_THREE_EDGE;
		for(i=1; i<=TYPE_THREE_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_THREE_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[3];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[4];
		MyEdge[6].v1 = MyNode[1];
		MyEdge[6].v2 = MyNode[3];
		MyEdge[7].v1 = MyNode[1];
		MyEdge[7].v2 = MyNode[2];
	}
	else if(type == 4)
	{
		NodeNum = TYPE_FOUR_NODE;
		EdgeNum = TYPE_FOUR_EDGE;
		for(i=1; i<=TYPE_FOUR_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_FOUR_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[3];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[4];
		MyEdge[6].v1 = MyNode[1];
		MyEdge[6].v2 = MyNode[3];
		MyEdge[7].v1 = MyNode[1];
		MyEdge[7].v2 = MyNode[2];
		MyEdge[8].v1 = MyNode[1];
		MyEdge[8].v2 = MyNode[5];
		MyEdge[9].v1 = MyNode[5];
		MyEdge[9].v2 = MyNode[3];
	}
	else if(type == 5)
	{
		NodeNum = TYPE_FIVE_NODE;
		EdgeNum = TYPE_FIVE_EDGE;
		for(i=1; i<=TYPE_FIVE_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_FIVE_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[1];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[5];
		MyEdge[6].v1 = MyNode[3];
		MyEdge[6].v2 = MyNode[5];
	}
	else if(type == 6)
	{
		NodeNum = TYPE_SIX_NODE;
		EdgeNum = TYPE_SIX_EDGE;
		for(i=1; i<=TYPE_SIX_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_SIX_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[1];
		MyEdge[1].v2 = MyNode[2];
		MyEdge[2].v1 = MyNode[2];
		MyEdge[2].v2 = MyNode[3];
		MyEdge[3].v1 = MyNode[3];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[4];
		MyEdge[6].v1 = MyNode[1];
		MyEdge[6].v2 = MyNode[5];
		MyEdge[7].v1 = MyNode[3];
		MyEdge[7].v2 = MyNode[5];
		MyEdge[8].v1 = MyNode[2];
		MyEdge[8].v2 = MyNode[4];
	}
	else if(type == 7)
	{
		NodeNum = TYPE_SEVEN_NODE;
		EdgeNum = TYPE_SEVEN_EDGE;
		for(i=1; i<=TYPE_SEVEN_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_SEVEN_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[2];
		MyEdge[1].v2 = MyNode[3];
		MyEdge[2].v1 = MyNode[3];
		MyEdge[2].v2 = MyNode[4];
		MyEdge[3].v1 = MyNode[1];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[4];
		MyEdge[4].v2 = MyNode[1];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[5];
		MyEdge[6].v1 = MyNode[3];
		MyEdge[6].v2 = MyNode[5];
		MyEdge[7].v1 = MyNode[2];
		MyEdge[7].v2 = MyNode[3];
	}
	else if(type == 8)
	{
		NodeNum = TYPE_EIGHT_NODE;
		EdgeNum = TYPE_EIGHT_EDGE;
		for(i=1; i<=TYPE_EIGHT_NODE; i++)
			MyNode[i] = i;
		for(i=1; i<=TYPE_EIGHT_EDGE; i++)
			MyEdge[i].num = i;
		MyEdge[1].v1 = MyNode[2];
		MyEdge[1].v2 = MyNode[3];
		MyEdge[2].v1 = MyNode[3];
		MyEdge[2].v2 = MyNode[4];
		MyEdge[3].v1 = MyNode[1];
		MyEdge[3].v2 = MyNode[4];
		MyEdge[4].v1 = MyNode[2];
		MyEdge[4].v2 = MyNode[3];
		MyEdge[5].v1 = MyNode[1];
		MyEdge[5].v2 = MyNode[5];
		MyEdge[6].v1 = MyNode[3];
		MyEdge[6].v2 = MyNode[5];
		MyEdge[7].v1 = MyNode[2];
		MyEdge[7].v2 = MyNode[3];
	}
}

//judge whether has the Euler path, if yes return type
int JudgePath()
{
	int i, j;
	int count;
	int source = 1;
	count = 0;

	//record the degree of nodes
	for(i=1; i<=NodeNum; i++)
	{
		Degree[i] = 0;
		for(j=1; j<=EdgeNum; j++)
		{
			if(MyEdge[j].v1 == MyNode[i] || MyEdge[j].v2 == MyNode[i])
				Degree[i]++;
		}
		if(Degree[i] % 2 == 1)
		{
			count++;
			source = MyNode[i];
		}
	}

	//check the degree whether meet Euler theorem
	if(count == 0 || count == 2)
		return count;
	else
		return -1;
}

//find unaccess the edge
int JudgeEdge(Path mypath, int node, int *avail)
{
	int i, j;
	int count = 0;
	for(i=1; i<=EdgeNum; i++)
	{
		for(j=0; j<mypath.edge_num; j++)
		{
			if(mypath.path_edge[j].num == MyEdge[i].num)
				break;
		}
		if(j == mypath.edge_num || mypath.edge_num == 0)
		{
			if(MyEdge[i].v1 == node || MyEdge[i].v2 == node)
			{			
					avail[count++] = MyEdge[i].num;
			}
		}
	}
	return count;
}

//judge the road whether good according to type
int JudgeRoad(Path mypath, int type)
{
	if(type == 0)
	{
		if(mypath.edge_num == TYPE_ZERO_EDGE)
			return 1;
	}
	if(type == 1)
	{
		if(mypath.edge_num == TYPE_ONE_EDGE)
			return 1;
	}
	else if(type == 2)
	{
		if(mypath.edge_num == TYPE_TWO_EDGE)
			return 1;
	}
	else if(type == 3)
	{
		if(mypath.edge_num == TYPE_THREE_EDGE)
			return 1;
	}
	else if(type == 4)
	{
		if(mypath.edge_num == TYPE_FOUR_EDGE)
			return 1;
	}
	else if(type == 5)
	{
		if(mypath.edge_num == TYPE_FIVE_EDGE)
			return 1;
	}
	else if(type == 6)
	{
		if(mypath.edge_num == TYPE_SIX_EDGE)
			return 1;
	}
	else if(type == 7)
	{
		if(mypath.edge_num == TYPE_SEVEN_EDGE)
			return 1;
	}
	else if(type == 8)
	{
		if(mypath.edge_num == TYPE_EIGHT_EDGE)
			return 1;
	}
	return 0;
}

//get Euler path according to type
int GetEulerPath(int type)
{
	int top;	//stack top pointer 
	Path stack[STACK_MAX];	//stack
	Path temp;				//temp path
	Path swap;				//swap path
	int avail[AVAIL_MAX];	//avail edge
	int this_node;			//now node
	int count;
	int i, j;
	int v1, v2;
	int road_count;			//number of proper road
	int source;
	int mytype;

	//check the graph whether has Euler path
	mytype = JudgePath();
	if(mytype == -1)
		return 0;

	road_count = 0;
	//record the degree of nodes
	for(i=1; i<=NodeNum; i++)
	{
		Degree[i] = 0;
		for(j=1; j<=EdgeNum; j++)
		{
			if(MyEdge[j].v1 == MyNode[i] || MyEdge[j].v2 == MyNode[i])
				Degree[i]++;
		}

		//check source node from the degree of node
		if(mytype == 2)
		{
			if(Degree[i] % 2 == 1)
				source = MyNode[i];
			else
				continue;
		}
		else
			source = MyNode[i];
		temp.path_node[0] = source;
		
		//initialize and set node as origianl to push in stack
		top = 0;
		temp.edge_num = 0;
		temp.node_num = 1;
		memcpy(&stack[top++], &temp, sizeof(temp));

		//DFS stack loop
		while(top != 0)
		{
			top--;
			memcpy(&temp, &stack[top], sizeof(stack[top]));
			this_node = temp.path_node[temp.node_num-1];
			count = JudgeEdge(temp, this_node, avail);		//find all available edge

			//search available edge
			if(count != 0)
			{ 
				for(j=0; j<count; j++)
				{
					memcpy(&swap, &temp, sizeof(temp));
					swap.path_edge[swap.edge_num++] = MyEdge[avail[j]];
					v1 = MyEdge[avail[j]].v1;
					v2 = MyEdge[avail[j]].v2;
					if(v1 == this_node)
						swap.path_node[swap.node_num++] = MyEdge[avail[j]].v2;
					else if(v2 == this_node)
						swap.path_node[swap.node_num++] = MyEdge[avail[j]].v1;
					memcpy(&stack[top++], &swap, sizeof(swap));
				}
			}

			//no search available edge, dead road or good road
			else
			{
				if(JudgeRoad(temp, type) == 1)
				{
					for(j=0; j<temp.edge_num; j++)
						printf("[%d]->%d->", temp.path_node[j], temp.path_edge[j].num);
					printf("[%d]\n", temp.path_node[j]);
					road_count ++;
				}
			}
		}
	}
	return road_count;
}

int main()
{
	int road_count;
	int type;
	printf("------------ ŷ·ļ ------------\n");
	printf("һ8ѡͼͼʾο\n");
	printf("ڽ, '[i]' ʾڵ, 'i' ʾš\n");
	printf("9ʾ˳\n\n");
	type = 8;
	while(type != 9)
	{
		printf("ͼ(1--8): ");
		scanf("%d", &type);

		if(type >= 0 && type <= 8)
		{
			CreateGraph(type);
			road_count = GetEulerPath(type);
			if(road_count == 0)
				printf("ûŷ·!\n\n");
			else
				printf("·Ϊ: %d\n\n", road_count);
		}
		else if(type == 9)
			printf("лʹó\n\n");
		else
			printf("Ƿ!\n\n");
	}
	system("PAUSE");
}